   1 REM HexAid
     based on a program in
     "Supercharge Your Spectrum"
     by David M Webb
     (pub.Melbourne House,1983)
   2 REM modified by
     Jim Grimwood 2001/2005
   + byte counts + list width
   + error trapping & defaults
   + dec&hex addresses in lists
   + dec/hex converter
   + text entry option
   3 GO SUB 2000:GO TO 110
  10 LET a1=INT (v/k4k):LET a2=INT ((v-a1*k4k)/kqk):LET a3=INT (
     (v-a1*k4k-a2*kqk)/k16):LET a4=v-a1*k4k-a2*kqk-a3*k16
  12 IF  NOT v THEN
       PRINT "    ";v;
  14 IF v THEN
       PRINT "    "( TO 4-INT (LN v/LN 10));v;
  16 PRINT ":";b$(a1+k1);b$(a2+k1);b$(a3+k1);b$(a4+k1);":";
  18 RETURN
 110 POKE 23658,8:CLS:GO SUB srS:PRINT '"Menu:"
 120 PRINT '"[1]:WRITE a new routine"
 130 PRINT '"[2]:ALTER a routine"
 140 PRINT '"[3]:LIST hex code"
 150 PRINT '"[4]:SAVE a routine"
 160 PRINT '"[5]:LOAD a routine"
 180 PRINT '"[6]:CLEAR the machine code area"
 185 PRINT '"[7]:CONVERT dec/hex"
 187 PRINT '"[0]:STOP this program"
 190 PRINT #k0;AT k1,k0;"Please press appropriate key"
 200 IF INKEY$<>"" THEN
       GO TO 200
 210 LET g$=INKEY$:IF g$<"0" OR g$>"7" THEN
       GO TO 210
 220 IF g$="0" THEN
       STOP
 230 CLS:POKE 23728,CODE g$:GO SUB srS:GO SUB 930
 251 IF g$="1" THEN
       GO TO 260
 252 IF g$="2" THEN
       GO TO 450
 253 IF g$="3" THEN
       GO TO 490
 254 IF g$="4" THEN
       GO TO 580
 255 IF g$="5" THEN
       GO TO 700
 257 IF g$="6" THEN
       GO TO 810
 258 IF g$="7" THEN
       GO TO 1100
 259 GO TO 210
 260 REM WRITE a new routine
 280 GO SUB 995:IF v THEN
       CLEAR ramtop-v:GO SUB 2000
 285 GO SUB srS:GO SUB 930:LET v=ramtop+k1:LET ds=v
 300 LET v$=""
 310 IF v$="" THEN
       LET text=k0:PRINT :GO SUB k10:INPUT "Hex code=>";v$:
       GO SUB 935:GO TO 310
 320 IF v$(k1)="!" AND  NOT text THEN
       LET text=k1:LET v$=v$(k2 TO )
 330 IF  NOT text AND LEN v$/k2<>INT (LEN v$/k2) THEN
       PRINT "Incorrect entry";:GO TO 300
 340 IF text THEN
       LET i=CODE v$(k1):GO TO 400
 350 LET i=k0:FOR m=k1 TO k16 STEP 15
 360 LET g=CODE v$(k1+(m=k1))
 370 IF g<48 OR g>70 OR g>57 AND g<65 THEN
       PRINT "Incorrect entry";:GO TO 300
 380 LET i=i+m*((g<58)*(g-48)+(g>64 AND g<71)*(g-55)):NEXT m
 400 POKE v,i:LET v=v+k1:PRINT v$( TO k1+ NOT text);:LET v$=v$(2
     + NOT text TO )
 430 IF v=USR "A" THEN
       PRINT '"Warning: Entering UDG area!":REM GO TO 300
 440 GO TO 310
 450 REM ALTER a routine
 460 PRINT '"Alter from address:";:GO SUB srV:IF v<ramtop+k1
      THEN
       GO TO 460
 480 LET ds=v:GO TO 300
 490 REM LIST hex code
 510 PRINT '"List address:";:GO SUB srV
 515 PRINT '"Bytes/line[1-8]:";:INPUT LINE v$:IF LEN v$<>k1 OR v
     $<"1" OR v$>"8" THEN
       GO TO 515
 520 LET bl=VAL v$:PRINT bl'
 530 GO SUB k10
 540 FOR n=k1 TO bl
 542 IF v+n-k1<=65535 THEN
       LET g=INT (PEEK v/k16):LET h=PEEK v-k16*g:PRINT b$(g+k1);
       b$(h+k1);:LET v=v+k1
 544 NEXT n
 560 IF INKEY$="M" OR v>65535 THEN
       PRINT 'FLASH k1;"=>":PAUSE k0:RUN
 570 PRINT :GO TO 530
 580 REM SAVE a routine
 590 PRINT '"Save from address:";:GO SUB srV
 600 PRINT '"Length of routine:";:INPUT LINE v$:IF v$="" THEN
       LET v$=STR$ mc
 602 GO SUB srM:PRINT v$
 610 PRINT '"Name of routine:";:INPUT n$:PRINT n$
 620 SAVE n$CODE v,VAL v$
 630 INPUT "Verify? [YN]";i$:IF i$<>"Y" THEN
       RUN
 660 PRINT '"Rewind and press ""PLAY"""
 670 VERIFY n$CODE v,VAL v$
 680 PRINT '"O.K.":PAUSE 50:RUN
 700 REM LOAD a routine
 710 INPUT "Extend m/code area? [YN]";v$:GO SUB srM:IF v$<>"Y"
      THEN
       GO TO 770
 755 GO SUB 995:IF v>0 THEN
       CLEAR ramtop-v:GO SUB 2000
 760 GO SUB srS:GO SUB 930
 770 PRINT '"Load to address:";:GO SUB srV:IF v<16384 THEN
       GO TO 770
 780 PRINT '"Routine name:";:INPUT n$:PRINT n$
 790 PRINT '"Press ""PLAY"" on tape"
 800 LOAD n$CODE v:GO TO 680
 810 REM CLEAR the m/code area
 820 INPUT "Are you sure? [YN]";v$:IF v$="Y" THEN
       CLEAR USR "A"-k1:GO SUB 2000
 830 RUN
 870 REM SETUP
 880 LET ramtop=PEEK 23730+256*PEEK 23731
 900 PRINT "Start  of m/code area = ";ramtop+k1
 910 LET mc=USR "A"-ramtop-k1:PRINT "Length of m/code area = ";m
     c
 915 LET b$="0123456789ABCDEF":RETURN
 930 PRINT '"To return to the menu,enter ""M""":LET g$=CHR$
     PEEK 23728:IF g$="1" OR g$="2" THEN
       PRINT "Text entry, start line with ""!"""
 931 RETURN
 935 IF v$="M" THEN
       PRINT ''v-ds;" bytes entered ";FLASH k1;"=>":PAUSE k0
 940 IF v$="M" THEN
       RUN
 950 RETURN
 960 GO SUB 1105: LET v$=STR$ v
 965 GO SUB srM:IF v$="" THEN
       LET v$=STR$ (ramtop+k1)
 970 LET v=VAL v$:LET v=v*(v>=k0 AND v<=65535):PRINT v
 990 RETURN
 995 INPUT "D|H+Len|Loc of routine:";LINE v$:GO SUB 1111:LET v$=
     STR$ v:GO SUB 965:IF v>=16384 THEN
       LET v=ramtop-v+k1
 997 CLS:RETURN
1100 REM CONVERT dec/hex
1105 INPUT "D|H + 1-5 digits:";LINE v$:GO SUB srM:IF LEN v$<k2
      THEN
       LET v$="D"+STR$ (ramtop+k1)
1110 PRINT
1111 LET d$=v$(k1):LET v$=v$(k2 TO )
1112 LET lena=LEN v$:IF d$="D" THEN
       LET v=VAL v$:IF lena<=5 AND v=INT v AND v<=65535 THEN
         GO TO 1135
1113 IF d$<>"H" OR lena>k4 THEN
       GO TO 1105
1115 IF lena<k4 THEN
       LET v$="0000"(k1 TO k4-lena)+v$
1120 LET v=k0:FOR g=k1 TO k4
1122 LET d$=v$(g):LET w=k0
1123 IF d$>="0" AND d$<="9" OR d$>="A" AND d$<="F" THEN
       LET w=VAL d$
1125 LET v=v+w*k2^(k16-k4*g)
1130 NEXT g
1135 IF g$="7" THEN
       GO SUB k10:GO TO 1105
1140 RETURN
2000 REM Set Constants
2002 LET a=VAL "10":LET b=VAL "11":LET c=VAL "12":LET d=VAL "13"
     :LET e=VAL "14":LET f=VAL "15"
2010 LET k0=0:LET k1=1:LET k2=2:LET k4=4:LET k10=10:LET k16=16:
     LET kqk=256:LET k4k=4096:LET srS=870:LET srM=940:LET srV=96
     0:RETURN
** END OF FILE **